Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsed_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsed_medusa.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsed_medusa.F90	(revision 6639)
@@ -23,5 +23,7 @@
    !! AXY (10/02/09)
    USE iom
-
+   !! USE trc_nam_dia         ! JPALM 13-11-2015 -- if iom_use for diag
+   !! USE trc_nam_iom_medusa  ! JPALM 13-11-2015 -- if iom_use for diag
+   USE fldread         !  time interpolation
    USE lbclnk
    USE prtctl_trc      ! Print control for debbuging
@@ -39,13 +41,20 @@
 
    !! AXY (10/02/09)
-   LOGICAL, PUBLIC ::                  &
-      bdustfer = .TRUE.
+   LOGICAL, PUBLIC  ::   bdustfer  !: boolean for dust input from the atmosphere
    REAL(wp), PUBLIC ::                 &
       sedfeinput = 1.e-9_wp  ,         &
       dustsolub  = 0.014_wp
+
+   INTEGER , PARAMETER :: nbtimes = 365  !: maximum number of times record in a file
+   INTEGER  :: ntimes_dust               ! number of time steps in a file
+
    INTEGER ::                          &
       numdust,                         &
       nflx1,  nflx2,                   &
       nflx11, nflx12
+   
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_dust      ! structure of input dust
+
+   
    !!* Substitution
 #  include "domzgr_substitute.h90"
@@ -90,6 +99,16 @@
 
       CHARACTER (len=25) :: charout
+      
+      !! JPALM - 26-11-2015 -add iom_use for diagnostic
+       REAL(wp), POINTER, DIMENSION(:,:  ) :: zw2d
       !!---------------------------------------------------------------------
-
+      !!
+      IF( lk_iomput) THEN  
+           IF( med_diag%DSED%dgsave ) THEN
+               CALL wrk_alloc( jpi, jpj,      zw2d )
+                zw2d(:,:)      = 0.0      !!
+           ENDIF
+      ENDIF
+      
       !! AXY (10/02/09)
       jnt = 1
@@ -120,5 +139,17 @@
 
       !! AXY (10/02/09)
-      IF( (jnt == 1) .and. (bdustfer) )  CALL trc_sed_medusa_sbc( kt )
+      !!IF( (jnt == 1) .and. (bdustfer) )  CALL trc_sed_medusa_sbc( kt )
+      !! JPALM -- 31-03-2016 -- rewrite trc_sed_medusa_sbc.
+      !! IF (kt == nittrc000 ) CALL trc_sed_medusa_sbc 
+      IF( bdustfer ) THEN
+         IF( kt == nittrc000 .OR. ( kt /= nittrc000 .AND. ntimes_dust > 1 ) ) THEN
+            CALL fld_read( kt, 1, sf_dust )
+            dust(:,:) = sf_dust(1)%fnow(:,:,1)
+         ENDIF
+      ELSE
+         dust(:,:) = 0.0
+      ENDIF
+      !!
+           
       !!
       zirondep(:,:,:) = 0.e0     !! Initialisation of deposition variables
@@ -165,6 +196,12 @@
                trbio(ji,jj,jk,8) = ztra
 # endif
-               IF( ln_diatrc ) &
-                  &  trc2d(ji,jj,8) = trc2d(ji,jj,8) + ztra * fse3t(ji,jj,jk) * 86400.
+               IF (lk_iomput .AND. .NOT. ln_diatrc) THEN
+                     IF( med_diag%DSED%dgsave ) THEN
+                         zw2d(ji,jj) = zw2d(ji,jj) + ztra * fse3t(ji,jj,jk) * 86400
+                      ENDIF   
+               ELSE IF( ln_diatrc )  THEN
+                    trc2d(ji,jj,8) = trc2d(ji,jj,8) + ztra * fse3t(ji,jj,jk) * 86400
+               ENDIF    
+                
             END DO
          END DO
@@ -175,8 +212,14 @@
 # endif
       IF( ln_diatrc ) CALL lbc_lnk( trc2d(:,:,8), 'T', 1. )      ! Lateral boundary conditions on trc2d
-# if defined key_iomput
-      CALL iom_put( "DSED",trc2d(:,:,8) )
-# endif
-
+      !!
+      IF (lk_iomput .AND. .NOT. ln_diatrc) THEN
+           IF( med_diag%DSED%dgsave ) THEN
+                CALL iom_put( "DSED"  ,  zw2d)
+                CALL wrk_dealloc( jpi, jpj,    zw2d  )
+            ENDIF
+      ELSE IF (lk_iomput .AND. ln_diatrc)  THEN    
+          CALL iom_put( "DSED",trc2d(:,:,8) )
+      ENDIF
+      !!
 # if defined key_roam
 
@@ -238,4 +281,9 @@
 
    !! AXY (10/02/09)
+   !! JPALM -- 31-03-2016 -- Completely change trc_sed_medusa_sbc.
+   !!                     -- We now need to read dust file through a namelist.
+   !!                     To be able to use time varying dust depositions from
+   !!                     -- copy and adapt the PISCES p4z_sbc_ini subroutine
+   !!                     -- Only use the dust related part.      
    SUBROUTINE trc_sed_medusa_sbc(kt)
 
@@ -243,97 +291,91 @@
       !!                  ***  ROUTINE trc_sed_medusa_sbc  ***
       !!
-      !! ** Purpose :   Read and interpolate the external sources of 
-      !!                nutrients
-      !!
-      !! ** Method  :   Read the files and interpolate the appropriate variables
-      !!
-      !! ** input   :   external netcdf files
+      !! ** Purpose :   Read and dust namelist and files.
+      !!                The interpolation is done in trc_sed through 
+      !!                "CALL fld_read( kt, 1, sf_dust )"
+      !!
+      !! ** Method  :   Read the sbc namelist, and the adapted dust file, if required
+      !!                called at the first timestep (nittrc000)
+      !!
+      !! ** input   :   -- namelist sbc ref and cfg
+      !!                -- external netcdf files
       !!
       !!----------------------------------------------------------------------
       !! * arguments
       INTEGER, INTENT( in  ) ::   kt   ! ocean time step
-
-      !! * Local declarations
-      INTEGER ::   &
-         imois, imois2,       &  ! temporary integers
-         i15  , iman             !    "          "
-      REAL(wp) ::   &
-         zxy                     !    "         "
+      INTEGER  :: ji, jj, jk, jm, ifpr
+      INTEGER  :: ii0, ii1, ij0, ij1
+      INTEGER  :: numdust
+      INTEGER  :: ierr 
+      INTEGER  :: ios                 ! Local integer output status for namelist read
+      INTEGER  :: isrow             ! index for ORCA1 starting row
+      REAL(wp) :: ztimes_dust
+      REAL(wp), DIMENSION(nbtimes) :: zsteps                 ! times records
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: zdust
+      !
+      CHARACTER(len=100) ::  cn_dir          ! Root directory for location of ssr files
+      TYPE(FLD_N) ::   sn_dust               ! informations about the fields to be read
+      !
+      NAMELIST/nammedsbc/cn_dir, sn_dust, bdustfer 
 
       !!---------------------------------------------------------------------
-
-      !! Initialization
-      !! --------------
-      !!
-      i15 = nday / 16
-      iman  = INT( raamo )
-      imois = nmonth + i15 - 1
-      IF( imois == 0 ) imois = iman
-      imois2 = nmonth
-
-      !! 1. first call kt=nittrc000
-      !! -----------------------
-      !!
-      IF( kt == nittrc000 ) THEN
-         ! initializations
-         nflx1  = 0
-         nflx11 = 0
-         ! open the file
-         IF(lwp) THEN
-            WRITE(numout,*) ' '
-            WRITE(numout,*) ' **** Routine trc_sed_medusa_sbc'
+      !
+      IF( nn_timing == 1 )  CALL timing_start('trc_sed_medusa_sbc')
+      !
+      !                            !* set file information
+      REWIND( numnatp_ref )        ! Namelist nammedsbc in reference namelist : MEDUSA external sources of Dust
+      READ  ( numnatp_ref, nammedsbc, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammedsbc in reference namelist', lwp )
+
+      REWIND( numnatp_cfg )        ! Namelist nammedsbc in configuration namelist : MEDUSA external sources of Dust
+      READ  ( numnatp_cfg, nammedsbc, IOSTAT = ios, ERR = 902 )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammedsbc in configuration namelist', lwp )
+      IF(lwm) WRITE ( numonp, nammedsbc )
+
+      IF(lwp) THEN
+         WRITE(numout,*) ' '
+         WRITE(numout,*) ' namelist : nammedsbc '
+         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~ '
+         WRITE(numout,*) '    dust input from the atmosphere           bdustfer     = ', bdustfer
+      END IF
+
+      ! dust input from the atmosphere
+      ! ------------------------------
+      IF( bdustfer ) THEN
+         !
+         IF(lwp) WRITE(numout,*) '    initialize dust input from atmosphere '
+         IF(lwp) WRITE(numout,*) '    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ '
+         !
+         !! already allocated in sms_medusa
+         !!ALLOCATE( dust(jpi,jpj) )    ! allocation
+         !
+         ALLOCATE( sf_dust(1), STAT=ierr )           !* allocate and fill sf_sst (forcing structure) with sn_sst
+         IF( ierr > 0 )   CALL ctl_stop( 'STOP', 'trc_sed_medusa_sbc: unable to allocate sf_dust structure' )
+         !
+         CALL fld_fill( sf_dust, (/ sn_dust /), cn_dir, 'trc_sed_medusa_sbc', 'Atmospheric dust deposition', 'nammedsed' )
+                                   ALLOCATE( sf_dust(1)%fnow(jpi,jpj,1)   )
+         IF( sn_dust%ln_tint )     ALLOCATE( sf_dust(1)%fdta(jpi,jpj,1,2) )
+         !
+         IF( Agrif_Root() ) THEN   !  Only on the master grid
+            ! Get total input dust ; need to compute total atmospheric supply of Si in a year
+            CALL iom_open (  TRIM( sn_dust%clname ) , numdust )
+            CALL iom_gettime( numdust, zsteps, kntime=ntimes_dust)  ! get number of record in file
+            ALLOCATE( zdust(jpi,jpj,ntimes_dust) )
+            DO jm = 1, ntimes_dust
+               CALL iom_get( numdust, jpdom_data, TRIM( sn_dust%clvar ), zdust(:,:,jm), jm )
+            END DO
+            CALL iom_close( numdust )
+            DEALLOCATE( zdust)
          ENDIF
-         CALL iom_open ( 'dust.orca.nc', numdust )
-	 IF(lwp) WRITE(numout,*) 'trc_sed_medusa_sbc: dust.orca.nc opened'
-      ENDIF
-
-      !! Read monthly file
-      !! ----------------
-      !!
-      IF( kt == nittrc000 .OR. imois /= nflx1 ) THEN
-
-         !! Calendar computation
-         !!
-         !! nflx1 number of the first file record used in the simulation
-         !! nflx2 number of the last  file record
-         !!
-         nflx1 = imois
-         nflx2 = nflx1+1
-         nflx1 = MOD( nflx1, iman )
-         nflx2 = MOD( nflx2, iman )
-         IF( nflx1 == 0 )   nflx1 = iman
-         IF( nflx2 == 0 )   nflx2 = iman
-         IF(lwp) WRITE(numout,*) 'trc_sed_medusa_sbc: first record file used nflx1 ',nflx1
-         IF(lwp) WRITE(numout,*) 'trc_sed_medusa_sbc: last  record file used nflx2 ',nflx2
-
-         !! Read monthly fluxes data
-         !!
-         !! humidity
-         !!
-         CALL iom_get ( numdust, jpdom_data, 'dust', dustmo(:,:,1), nflx1 )
-         CALL iom_get ( numdust, jpdom_data, 'dust', dustmo(:,:,2), nflx2 )
-
-         IF(lwp .AND. nitend-nit000 <= 100 ) THEN
-            WRITE(numout,*)
-            WRITE(numout,*) ' read clio flx ok'
-            WRITE(numout,*)
-            WRITE(numout,*)
-            WRITE(numout,*) 'Clio month: ',nflx1,'  field: dust'
-            CALL prihre( dustmo(:,:,1),jpi,jpj,1,jpi,20,1,jpj,10,1e9,numout )
-         ENDIF
-
-      ENDIF
-
-      !! 3. at every time step interpolation of fluxes
-      !! ---------------------------------------------
-      !!
-      zxy = FLOAT( nday + 15 - 30 * i15 ) / 30
-      dust(:,:) = ( (1.-zxy) * dustmo(:,:,1) + zxy * dustmo(:,:,2) )
-
-      IF( kt == nitend ) THEN
-         CALL iom_close (numdust)
-         IF(lwp) WRITE(numout,*) 'trc_sed_medusa_sbc: dust.orca.nc closed'
-      ENDIF
-
+         !
+         CALL fld_read( kt, 1, sf_dust )
+         dust(:,:) = sf_dust(1)%fnow(:,:,1)
+         !
+      ELSE
+         dust(:,:) = 0.0
+      END IF
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('trc_sed_medusa_sbc')
+      !
    END SUBROUTINE trc_sed_medusa_sbc
 
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsms_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsms_medusa.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcsms_medusa.F90	(revision 6639)
@@ -21,4 +21,5 @@
    USE trcopt_medusa
    USE trcsed_medusa
+   USE trcavg_medusa
 
 
@@ -46,4 +47,9 @@
       INTEGER, INTENT(in) :: kt   ! ocean time-step index
 
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' MEDUSA inside trc_sms_medusa'
+         CALL flush(numout)
+# endif
+
       IF( kt == nittrc000 ) THEN
        IF(lwp) WRITE(numout,*)
@@ -52,5 +58,15 @@
       ENDIF
 
+      CALL trc_avg_medusa( kt )   ! rolling average module
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' MEDUSA done trc_avg_medusa'
+         CALL flush(numout)
+# endif
+
       CALL trc_opt_medusa( kt )   ! optical model
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' MEDUSA done trc_opt_medusa'
+         CALL flush(numout)
+# endif
 
 # if defined key_kill_medusa
@@ -60,6 +76,14 @@
 # else
       CALL trc_bio_medusa( kt )   ! biological model
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' MEDUSA done trc_bio_medusa'
+         CALL flush(numout)
+# endif
 
       CALL trc_sed_medusa( kt )   ! sedimentation model
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' MEDUSA done trc_sed_medusa'
+         CALL flush(numout)
+# endif
 # endif
 
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 6639)
@@ -27,4 +27,5 @@
    USE ldftra_oce      ! lateral diffusion coefficient on tracers
    USE prtctl_trc      ! Print control
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
 
    IMPLICIT NONE
@@ -71,5 +72,5 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !
-      INTEGER ::   jk 
+      INTEGER ::   jk, jn 
       CHARACTER (len=22) ::   charout
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zun, zvn, zwn  ! effective velocity
@@ -105,4 +106,11 @@
       zvn(:,:,jpk) = 0._wp                                                     ! no transport trough the bottom
       zwn(:,:,jpk) = 0._wp                                                     ! no transport trough the bottom
+      ! 
+      !! Jpalm -- 14-01-2016 -- restart and proc pb - try this... 
+      DO jn = 1, jptra
+         CALL lbc_lnk( trn(:,:,:,jn), 'T', 1. )
+         CALL lbc_lnk( trb(:,:,:,jn), 'T', 1. )
+      END DO
+      !
 
       IF( lk_traldf_eiv .AND. .NOT. ln_traldf_grif )   &  ! add the eiv transport (if necessary)
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 6639)
@@ -102,15 +102,18 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~ '
 
-         IF( ln_rsttr .AND.    &                     ! Restart: read in restart  file
-            iom_varid( numrtr, 'sbc_'//TRIM(ctrcnm(1))//'_b', ldstop = .FALSE. ) > 0 ) THEN
-            IF(lwp) WRITE(numout,*) '          nittrc000-nn_dttrc surface tracer content forcing fields red in the restart file'
-            zfact = 0.5_wp
-            DO jn = 1, jptra
-               CALL iom_get( numrtr, jpdom_autoglo, 'sbc_'//TRIM(ctrcnm(jn))//'_b', sbc_trc_b(:,:,jn) )   ! before tracer content sbc
-            END DO
-         ELSE                                         ! No restart or restart not found: Euler forward time stepping
+         !! JPALM -- 12-01-2016 -- problem after restart, maybe because of this...
+         !!                     -- set sbc_trc_b to 0 after restart, first, to check.
+         !!------------------------------------------------------------------------------
+        ! IF( ln_rsttr .AND.    &                     ! Restart: read in restart  file
+        !    iom_varid( numrtr, 'sbc_'//TRIM(ctrcnm(1))//'_b', ldstop = .FALSE. ) > 0 ) THEN
+        !    IF(lwp) WRITE(numout,*) '          nittrc000-nn_dttrc surface tracer content forcing fields red in the restart file'
+        !    zfact = 0.5_wp
+        !    DO jn = 1, jptra
+        !       CALL iom_get( numrtr, jpdom_autoglo, 'sbc_'//TRIM(ctrcnm(jn))//'_b', sbc_trc_b(:,:,jn) )   ! before tracer content sbc
+        !    END DO
+        ! ELSE                                         ! No restart or restart not found: Euler forward time stepping
            zfact = 1._wp
            sbc_trc_b(:,:,:) = 0._wp
-         ENDIF
+        ! ENDIF
       ELSE                                         ! Swap of forcing fields
          IF( ln_top_euler ) THEN
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 6639)
@@ -27,4 +27,8 @@
    USE trcsbc          ! surface boundary condition          (trc_sbc routine)
    USE zpshde          ! partial step: hor. derivative       (zps_hde routine)
+# if defined key_debug_medusa
+   USE trcrst
+# endif
+
 
 #if defined key_agrif
@@ -65,8 +69,18 @@
          !
                                 CALL trc_sbc( kstp )            ! surface boundary condition
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' MEDUSA trc_trp after trc_sbc at kt =', kstp
+         CALL trc_rst_tra_stat
+         CALL flush(numout)
+# endif
          IF( lk_trabbl )        CALL trc_bbl( kstp )            ! advective (and/or diffusive) bottom boundary layer scheme
          IF( ln_trcdmp )        CALL trc_dmp( kstp )            ! internal damping trends
          IF( ln_trcdmp_clo )    CALL trc_dmp_clo( kstp )        ! internal damping trends on closed seas only
                                 CALL trc_adv( kstp )            ! horizontal & vertical advection 
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' MEDUSA trc_trp after trc_adv at kt =', kstp
+         CALL trc_rst_tra_stat
+         CALL flush(numout)
+# endif
                                 CALL trc_ldf( kstp )            ! lateral mixing
          IF( .NOT. lk_offline .AND. lk_zdfkpp )    &
@@ -76,5 +90,15 @@
 #endif
                                 CALL trc_zdf( kstp )            ! vertical mixing and after tracer fields
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' MEDUSA trc_trp after trc_zdf at kt =', kstp
+         CALL trc_rst_tra_stat
+         CALL flush(numout)
+# endif
                                 CALL trc_nxt( kstp )            ! tracer fields at next time step     
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' MEDUSA trc_trp after trc_nxt at kt =', kstp
+         CALL trc_rst_tra_stat
+         CALL flush(numout)
+# endif
          IF( ln_trcrad )        CALL trc_rad( kstp )            ! Correct artificial negative concentrations
 
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/par_trc.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/par_trc.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/par_trc.F90	(revision 6639)
@@ -8,4 +8,5 @@
    !!             1.0  !  2004-03  (C. Ethe) Free form and module
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  revised architecture
+   !!              -   !  2014-06  (A. Yool, J. Palmieri) adding MEDUSA-2
    !!----------------------------------------------------------------------
    USE par_kind          ! kind parameters
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 6639)
@@ -104,4 +104,44 @@
    END TYPE DIAG
 
+#if defined key_medusa && defined key_iomput
+   TYPE, PUBLIC :: BDIAG
+      LOGICAL              :: dgsave
+   END TYPE BDIAG
+   
+   TYPE, PUBLIC :: DIAG_IOM
+      TYPE(BDIAG) INVTN, INVTSI, INVTFE, PRN, MPN, PRD, MPD, DSED, OPAL, OPALDISS, GMIPn,           &
+                  GMID, MZMI, GMEPN, GMEPD, GMEZMI, GMED, MZME, DEXP, DETN, MDET, AEOLIAN, BENTHIC, &
+                  SCAVENGE, PN_JLIM, PN_NLIM, PN_FELIM, PD_JLIM, PD_NLIM, PD_FELIM, PD_SILIM,       &
+                  PDSILIM2, SDT__100, SDT__200, SDT__500, SDT_1000, TOTREG_N, TOTRG_SI, REG__100,   &
+                  REG__200, REG__500, REG_1000, FASTN, FASTSI, FASTFE, FASTC, FASTCA, FDT__100,     &
+                  FDT__200, FDT__500, FDT_1000, RG__100F, RG__200F, RG__500F, RG_1000F, FDS__100,   &
+                  FDS__200, FDS__500, FDS_1000, RGS_100F, RGS_200F, RGS_500F, RGS1000F, REMINN,     &
+                  REMINSI, REMINFE, REMINC, REMINCA, SEAFLRN, SEAFLRSI, SEAFLRFE, SEAFLRC, SEAFLRCA, &
+                  MED_QSR, MED_XPAR, INTFLX_N, INTFLX_SI, INTFLX_FE, INT_PN, INT_PD, ML_PRN, ML_PRD, &
+                  OCAL_CCD, OCAL_LVL, FE_0000, FE_0100, FE_0200, FE_0500, FE_1000, MED_XZE, WIND,   &
+                  ATM_PCO2, OCN_PH, OCN_PCO2, OCNH2CO3, OCN_HCO3, OCN_CO3, CO2FLUX, OM_CAL, OM_ARG, &
+                  TCO2, TALK, KW660, ATM_PP0, O2FLUX, O2SAT, CAL_CCD, ARG_CCD, SFR_OCAL, SFR_OARG,  &
+                  N_PROD, N_CONS, C_PROD, C_CONS, O2_PROD, O2_CONS, O2_ANOX, RR_0100, RR_0500,      &
+                  RR_1000, IBEN_N, IBEN_FE, IBEN_C, IBEN_SI, IBEN_CA, OBEN_N, OBEN_FE, OBEN_C,      &
+                  OBEN_SI, OBEN_CA, BEN_N, BEN_FE, BEN_C, BEN_SI, BEN_CA, RUNOFF, RIV_N, RIV_SI,    &
+                  RIV_C, RIV_ALK, DETC, SDC__100, SDC__200, SDC__500, SDC_1000, INVTC, INVTALK,     &
+                  INVTO2, LYSO_CA, COM_RESP, PN_LLOSS, PD_LLOSS, ZI_LLOSS, ZE_LLOSS, ZI_MES_N,      &
+                  ZI_MES_D, ZI_MES_C, ZI_MESDC, ZI_EXCR, ZI_RESP, ZI_GROW, ZE_MES_N, ZE_MES_D,      &
+                  ZE_MES_C, ZE_MESDC, ZE_EXCR, ZE_RESP, ZE_GROW, MDETC, GMIDC, GMEDC,               &
+                  BASIN_01, BASIN_02, BASIN_03, BASIN_04, BASIN_05, BASIN_06, BASIN_07, BASIN_08,   &
+                  BASIN_09, BASIN_10, BASIN_11, BASIN_12, BASIN_13, BASIN_14, BASIN_15, BASIN_16,   &
+                  BASIN_17, BASIN_18, BASIN_19, BASIN_20, BASIN_21, BASIN_22, BASIN_23, BASIN_24,   &
+                  BASIN_25, BASIN_26, BASIN_27, BASIN_28, BASIN_29, BASIN_30, BASIN_31, BASIN_32,   &
+                  BASIN_33, BASIN_34, BASIN_35, BASIN_36, BASIN_37, BASIN_38, BASIN_39, BASIN_40,   &
+                  BASIN_41, BASIN_42, BASIN_43, BASIN_44, BASIN_45,                                 &
+                  INT_ZMI, INT_ZME, INT_DET, INT_DTC, DMS_SURF, DMS_ANDR, DMS_SIMO, DMS_ARAN,       &
+                  DMS_HALL,   &
+                  TPP3, DETFLUX3, REMIN3N, PH3, OM_CAL3      
+                  !! list of all MEDUSA diagnostics that could be called by iom_use
+   END TYPE DIAG_IOM  
+   !!
+   TYPE(DIAG_IOM), PUBLIC :: med_diag  ! define which diagnostics are asked in outputs
+# endif                   
+
    !! information for inputs
    !! --------------------------------------------------
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 6639)
@@ -103,9 +103,9 @@
 
       IF( lk_pisces  )       CALL trc_ini_pisces       ! PISCES  bio-model
+      IF( lk_medusa  )       CALL trc_ini_medusa       ! MEDUSA  tracers
+      IF( lk_idtra   )       CALL trc_ini_idtra        ! Idealize tracers
       IF( lk_cfc     )       CALL trc_ini_cfc          ! CFC     tracers
       IF( lk_c14b    )       CALL trc_ini_c14b         ! C14 bomb  tracer
       IF( lk_my_trc  )       CALL trc_ini_my_trc       ! MY_TRC  tracers
-      IF( lk_medusa  )       CALL trc_ini_medusa       ! MEDUSA  tracers
-      IF( lk_idtra   )       CALL trc_ini_idtra        ! Idealize tracers
 
       CALL trc_ice_ini                                 ! Tracers in sea ice
@@ -274,4 +274,8 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~'
       IF(lwp) CALL flush(numout)
+# if defined key_debug_medusa
+         CALL trc_rst_stat
+         CALL flush(numout)
+# endif
 
 9000  FORMAT(' tracer nb : ',i2,'      name :',a10,'      initial content :',e18.10)
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 6639)
@@ -11,4 +11,5 @@
    !!              -   !  2001-01 (E Kestenare) suppress ndttrc=1 for CEN2 and TVD schemes
    !!             1.0  !  2005-03 (O. Aumont, A. El Moussaoui) F90
+   !!              -   !  2014-06  (A. Yool, J. Palmieri) adding MEDUSA-2
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -56,5 +57,5 @@
       !! ** Method  : - read passive tracer namelist 
       !!              - read namelist of each defined SMS model
-      !!                ( (PISCES, CFC, MY_TRC )
+      !!                ( (PISCES, CFC, MY_TRC, MEDUSA, IDTRA )
       !!---------------------------------------------------------------------
       INTEGER  ::   jn, jk                     ! dummy loop indice
@@ -235,5 +236,5 @@
       IF (lwp) write (numout,*) '------------------------------'
       IF (lwp) write (numout,*) 'Jpalm - debug'
-      IF (lwp) write (numout,*) 'CALL trc_nam_pisces -- OK'
+      IF (lwp) write (numout,*) 'CALL trc_nam_pisces  -- OK'
       IF (lwp) write (numout,*) 'in trc_nam - just before CALL trc_nam_medusa'
       IF (lwp) write (numout,*) ' '
@@ -269,5 +270,14 @@
       ELSE                    ;   IF(lwp) WRITE(numout,*) '          CFC not used'
       ENDIF
-
+      !
+# if defined key_debug_medusa
+      CALL flush(numout)
+      IF (lwp) write (numout,*) '------------------------------'
+      IF (lwp) write (numout,*) 'Jpalm - debug'
+      IF (lwp) write (numout,*) 'CALL trc_nam_cfc -- OK'
+      IF (lwp) write (numout,*) 'in trc_nam - CALL trc_nam OK'
+      IF (lwp) write (numout,*) ' '
+# endif
+      !
       IF( lk_c14b     ) THEN   ;   CALL trc_nam_c14b         ! C14 bomb     tracers
       ELSE                    ;   IF(lwp) WRITE(numout,*) '          C14 not used'
@@ -277,5 +287,5 @@
       ELSE                    ;   IF(lwp) WRITE(numout,*) '          MY_TRC not used'
       ENDIF
-      !
+       
       IF(lwp)   CALL flush(numout)
    END SUBROUTINE trc_nam
@@ -489,4 +499,6 @@
          trc3d(:,:,:,:) = 0._wp  ;   ctrc3d(:) = ' '   ;   ctrc3l(:) = ' '    ;    ctrc3u(:) = ' ' 
          !
+      !! ELSE IF  ( lk_iomput .AND. lk_medusa .AND. .NOT. ln_diatrc) THEN
+      !!    CALL trc_nam_iom_medusa
       ENDIF
 
